MODULE subs

INTERFACE

   SUBROUTINE mat_mult ( a, b, c, error )
   !
   !  Purpose:
   !    To multiply two-dimensional matrices A and B, and
   !    store the result in a third matrix C.  This version
   !    of the subroutine uses assumed-shape arrays and an
   !    explicit interface.
   !
   !  Record of revisions:
   !       Date       Programmer         Description of change
   !       ====       ==========         =====================
   !    05/20/2016    S. J. Chapman      Original code
   !
   IMPLICIT NONE

   ! List of calling arguments:
   REAL,INTENT(IN),DIMENSION(:,:) ::  a      ! Matrix A
   REAL,INTENT(IN),DIMENSION(:,:) ::  b      ! Matrix B
   REAL,INTENT(OUT),DIMENSION(:,:) :: c      ! Matrix C
   INTEGER,INTENT(OUT) :: error      ! Error flag: 0 = No error
                                     !             1 = size mismatch
                                     !             2 = C too small
   END SUBROUTINE mat_mult
   
END INTERFACE

END MODULE subs
