SUBMODULE (subs) subs_exec

! This submodule contains executable code for the
! matrix multiplication procedure.

CONTAINS

MODULE PROCEDURE mat_mult

! List of local variables:
INTEGER :: i, j, k                ! Loop index
INTEGER :: nrow1                  ! No. of rows in A
INTEGER :: ncol1                  ! No. of cols in A
INTEGER :: nrow2                  ! No. of rows in B
INTEGER :: ncol2                  ! No. of cols in B
INTEGER :: nrow3                  ! No. of rows in C
INTEGER :: ncol3                  ! No. of cols in C

! Get size of matrices
nrow1 = UBOUND(a,1)
ncol1 = UBOUND(a,2)
nrow2 = UBOUND(b,1)
ncol2 = UBOUND(b,2)
nrow3 = UBOUND(c,1)
ncol3 = UBOUND(c,2)

! Is C large enough to hold the result?
IF ( nrow1 > nrow3 .OR. ncol2 > ncol3 ) THEN
   error = 2

! Are the sizes compatible?
ELSE IF ( ncol1 /= nrow2 ) THEN
   error = 1

ELSE

   ! Multiply elements
   DO i = 1, nrow1
      DO j = 1, ncol2
         c(i,j) = 0.
         DO k = 1, ncol1
            c(i,j) = C(i,j) + a(i,k) * b(k,j)
         END DO
      END DO
   END DO
   error = 0

END IF
END PROCEDURE mat_mult

END SUBMODULE subs_exec
